#=======================================================================
#                        C L I E N T
#=======================================================================
#########################################################################
# Function    : RalfRemoteCommand
# Description : Send some data to the server after setting up the port to it
# Author      : Tom Wilkason
# Date        : 6/2/1999
# Modify to keep socket open (using it as a state) and first thing
# send in USER/PASS pair to allow subsequent transmission
#########################################################################
set GlobVars(RALF,Server) bertha
set GlobVars(RALF,Port) 8775
proc ralf {params} {
   ;# Open the server and get a channel to it
   global errorInfo
   global GlobVars
   set errorInfo ""
   set s [Echo_Client $GlobVars(RALF,Server) $GlobVars(RALF,Port)]
   if {$s != 0} {
      # {param list}    00 cmd  xmms_remote

      puts $s "$params"         ;# Send command
      #puts "Trying ($params) on $GlobVars(RALF,Server)"
      ;# Read all the returned data, the channel will be closed by the
      ;# server when it processes th \n from above
      set result "EOF"
      if {! ([eof $s] || [catch {gets $s line} result])} {
         ;# Can add code to process result here rather than just print it out!!!
         set error [lindex $line 0]
         if {$error=="ERROR"} {
            puts "Error $line"
         } else {
            puts "$line"        ;# Read back result of command
         }
      } else {
         puts $result
      }
      close $s                ;# Close the socket, the server already closed his
   } else {
      puts "Error opening Server!"
   }
}
#########################################################################
# Function    : Echo_Client
# Description : Open up a channel to the server on user specified port
#               Return the fid or 0 if open failed
# Author      : Tom Wilkason
# Date        : 6/2/1999
#########################################################################
proc Echo_Client {host port} {
   set s 0
   if {[catch {set s [socket $host $port]}]} {
      puts "Can't open server host: $host on port: $port"
      return 0
   } else {
      fconfigure $s -buffering line -translation auto
      return $s
   }
}
# to use, paste into a tcl console type ralf xmms_... <param>

